﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace HealthcareSoft.Data
{
    using System;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;
    using System.Data.Entity.Core.Objects;
    using System.Linq;
    
    public partial class HealthCareDBContext : DbContext
    {
        public HealthCareDBContext()
            : base("name=HealthCareDBContext")
        {
        }
    
        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            throw new UnintentionalCodeFirstException();
        }
    
        public virtual DbSet<Allergy> Allergies { get; set; }
        public virtual DbSet<Appointment> Appointments { get; set; }
        public virtual DbSet<AppointmentDetail> AppointmentDetails { get; set; }
        public virtual DbSet<BloodGroup> BloodGroups { get; set; }
        public virtual DbSet<Department> Departments { get; set; }
        public virtual DbSet<Disease> Diseases { get; set; }
        public virtual DbSet<DoctorShift> DoctorShifts { get; set; }
        public virtual DbSet<DoctorsSchedule> DoctorsSchedules { get; set; }
        public virtual DbSet<Enqury> Enquries { get; set; }
        public virtual DbSet<Hospital> Hospitals { get; set; }
        public virtual DbSet<HospitalDepartmentMapping> HospitalDepartmentMappings { get; set; }
        public virtual DbSet<HospitalDoctorMapping> HospitalDoctorMappings { get; set; }
        public virtual DbSet<IntervalMaster> IntervalMasters { get; set; }
        public virtual DbSet<MaximumAppointmentTime> MaximumAppointmentTimes { get; set; }
        public virtual DbSet<Pill> Pills { get; set; }
        public virtual DbSet<PillsReminder> PillsReminders { get; set; }
        public virtual DbSet<Prescription> Prescriptions { get; set; }
        public virtual DbSet<PrescriptionAgainstPatient> PrescriptionAgainstPatients { get; set; }
        public virtual DbSet<PrescriptionPill> PrescriptionPills { get; set; }
        public virtual DbSet<Qualification> Qualifications { get; set; }
        public virtual DbSet<ReferedPatient> ReferedPatients { get; set; }
        public virtual DbSet<Report> Reports { get; set; }
        public virtual DbSet<Specialization> Specializations { get; set; }
        public virtual DbSet<Symptom> Symptoms { get; set; }
        public virtual DbSet<Token> Tokens { get; set; }
        public virtual DbSet<UserProfile> UserProfiles { get; set; }
        public virtual DbSet<UserRole> UserRoles { get; set; }
        public virtual DbSet<Week> Weeks { get; set; }
        public virtual DbSet<WorkingShift> WorkingShifts { get; set; }
    
        public virtual int AddAppointment(string reasonForVisit, Nullable<System.DateTime> appointmentDate, Nullable<System.DateTime> appointmentTime, Nullable<long> doctorId, Nullable<long> patientId, Nullable<long> symptomId)
        {
            var reasonForVisitParameter = reasonForVisit != null ?
                new ObjectParameter("ReasonForVisit", reasonForVisit) :
                new ObjectParameter("ReasonForVisit", typeof(string));
    
            var appointmentDateParameter = appointmentDate.HasValue ?
                new ObjectParameter("AppointmentDate", appointmentDate) :
                new ObjectParameter("AppointmentDate", typeof(System.DateTime));
    
            var appointmentTimeParameter = appointmentTime.HasValue ?
                new ObjectParameter("AppointmentTime", appointmentTime) :
                new ObjectParameter("AppointmentTime", typeof(System.DateTime));
    
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var patientIdParameter = patientId.HasValue ?
                new ObjectParameter("PatientId", patientId) :
                new ObjectParameter("PatientId", typeof(long));
    
            var symptomIdParameter = symptomId.HasValue ?
                new ObjectParameter("SymptomId", symptomId) :
                new ObjectParameter("SymptomId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("AddAppointment", reasonForVisitParameter, appointmentDateParameter, appointmentTimeParameter, doctorIdParameter, patientIdParameter, symptomIdParameter);
        }
    
        public virtual int AddAppointmentDetails(Nullable<long> appointmentId, Nullable<long> diseaseId, Nullable<long> allergieId, Nullable<long> symptomId, string clinicalNotes, Nullable<int> revisitTime, Nullable<long> createdBy)
        {
            var appointmentIdParameter = appointmentId.HasValue ?
                new ObjectParameter("AppointmentId", appointmentId) :
                new ObjectParameter("AppointmentId", typeof(long));
    
            var diseaseIdParameter = diseaseId.HasValue ?
                new ObjectParameter("DiseaseId", diseaseId) :
                new ObjectParameter("DiseaseId", typeof(long));
    
            var allergieIdParameter = allergieId.HasValue ?
                new ObjectParameter("AllergieId", allergieId) :
                new ObjectParameter("AllergieId", typeof(long));
    
            var symptomIdParameter = symptomId.HasValue ?
                new ObjectParameter("SymptomId", symptomId) :
                new ObjectParameter("SymptomId", typeof(long));
    
            var clinicalNotesParameter = clinicalNotes != null ?
                new ObjectParameter("ClinicalNotes", clinicalNotes) :
                new ObjectParameter("ClinicalNotes", typeof(string));
    
            var revisitTimeParameter = revisitTime.HasValue ?
                new ObjectParameter("RevisitTime", revisitTime) :
                new ObjectParameter("RevisitTime", typeof(int));
    
            var createdByParameter = createdBy.HasValue ?
                new ObjectParameter("CreatedBy", createdBy) :
                new ObjectParameter("CreatedBy", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("AddAppointmentDetails", appointmentIdParameter, diseaseIdParameter, allergieIdParameter, symptomIdParameter, clinicalNotesParameter, revisitTimeParameter, createdByParameter);
        }
    
        public virtual ObjectResult<AppoinmentDetails_Result> AppoinmentDetails(Nullable<long> doctorId, Nullable<System.DateTime> appointmentDate, Nullable<long> patientId)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var appointmentDateParameter = appointmentDate.HasValue ?
                new ObjectParameter("AppointmentDate", appointmentDate) :
                new ObjectParameter("AppointmentDate", typeof(System.DateTime));
    
            var patientIdParameter = patientId.HasValue ?
                new ObjectParameter("PatientId", patientId) :
                new ObjectParameter("PatientId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<AppoinmentDetails_Result>("AppoinmentDetails", doctorIdParameter, appointmentDateParameter, patientIdParameter);
        }
    
        public virtual ObjectResult<ConfirmOtp_Result> ConfirmOtp(Nullable<long> otp, Nullable<long> userId)
        {
            var otpParameter = otp.HasValue ?
                new ObjectParameter("Otp", otp) :
                new ObjectParameter("Otp", typeof(long));
    
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<ConfirmOtp_Result>("ConfirmOtp", otpParameter, userIdParameter);
        }
    
        public virtual ObjectResult<ConfirmPassword_Result> ConfirmPassword(Nullable<long> otp, Nullable<long> userId)
        {
            var otpParameter = otp.HasValue ?
                new ObjectParameter("Otp", otp) :
                new ObjectParameter("Otp", typeof(long));
    
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<ConfirmPassword_Result>("ConfirmPassword", otpParameter, userIdParameter);
        }
    
        public virtual ObjectResult<EditDoctorProfile_Result> EditDoctorProfile(Nullable<long> doctorId)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<EditDoctorProfile_Result>("EditDoctorProfile", doctorIdParameter);
        }
    
        public virtual int EditUserprofile(Nullable<long> userId, Nullable<int> userPin)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            var userPinParameter = userPin.HasValue ?
                new ObjectParameter("userPin", userPin) :
                new ObjectParameter("userPin", typeof(int));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("EditUserprofile", userIdParameter, userPinParameter);
        }
    
        public virtual ObjectResult<GetAppointmentDetailByPatientId_Result> GetAppointmentDetailByPatientId(Nullable<long> doctorId, Nullable<long> appointmentId)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var appointmentIdParameter = appointmentId.HasValue ?
                new ObjectParameter("AppointmentId", appointmentId) :
                new ObjectParameter("AppointmentId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetAppointmentDetailByPatientId_Result>("GetAppointmentDetailByPatientId", doctorIdParameter, appointmentIdParameter);
        }
    
        public virtual ObjectResult<GetAppointmentList_Result> GetAppointmentList(Nullable<long> userId, Nullable<int> type)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            var typeParameter = type.HasValue ?
                new ObjectParameter("Type", type) :
                new ObjectParameter("Type", typeof(int));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetAppointmentList_Result>("GetAppointmentList", userIdParameter, typeParameter);
        }
    
        public virtual ObjectResult<GetDeparment_Result> GetDeparment()
        {
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetDeparment_Result>("GetDeparment");
        }
    
        public virtual ObjectResult<GetDoctorAvailibility_Result> GetDoctorAvailibility(Nullable<long> doctorId)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetDoctorAvailibility_Result>("GetDoctorAvailibility", doctorIdParameter);
        }
    
        public virtual ObjectResult<GetDoctorsByDepartment_Result> GetDoctorsByDepartment(Nullable<long> departmentId)
        {
            var departmentIdParameter = departmentId.HasValue ?
                new ObjectParameter("DepartmentId", departmentId) :
                new ObjectParameter("DepartmentId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetDoctorsByDepartment_Result>("GetDoctorsByDepartment", departmentIdParameter);
        }
    
        public virtual ObjectResult<string> GetPatientname(string name)
        {
            var nameParameter = name != null ?
                new ObjectParameter("Name", name) :
                new ObjectParameter("Name", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<string>("GetPatientname", nameParameter);
        }
    
        public virtual ObjectResult<GetPillsReminderByUserId_Result> GetPillsReminderByUserId(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetPillsReminderByUserId_Result>("GetPillsReminderByUserId", userIdParameter);
        }
    
        public virtual ObjectResult<GetPrescriptionList_Result> GetPrescriptionList(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetPrescriptionList_Result>("GetPrescriptionList", userIdParameter);
        }
    
        public virtual ObjectResult<string> GetReportDetailsById(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("userId", userId) :
                new ObjectParameter("userId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<string>("GetReportDetailsById", userIdParameter);
        }
    
        public virtual ObjectResult<GetReportList_Result> GetReportList(Nullable<bool> isOrderByDate, Nullable<bool> orderByName, string doctorName, string clinicName, Nullable<int> limit, Nullable<int> offSet)
        {
            var isOrderByDateParameter = isOrderByDate.HasValue ?
                new ObjectParameter("IsOrderByDate", isOrderByDate) :
                new ObjectParameter("IsOrderByDate", typeof(bool));
    
            var orderByNameParameter = orderByName.HasValue ?
                new ObjectParameter("OrderByName", orderByName) :
                new ObjectParameter("OrderByName", typeof(bool));
    
            var doctorNameParameter = doctorName != null ?
                new ObjectParameter("DoctorName", doctorName) :
                new ObjectParameter("DoctorName", typeof(string));
    
            var clinicNameParameter = clinicName != null ?
                new ObjectParameter("ClinicName", clinicName) :
                new ObjectParameter("ClinicName", typeof(string));
    
            var limitParameter = limit.HasValue ?
                new ObjectParameter("Limit", limit) :
                new ObjectParameter("Limit", typeof(int));
    
            var offSetParameter = offSet.HasValue ?
                new ObjectParameter("OffSet", offSet) :
                new ObjectParameter("OffSet", typeof(int));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetReportList_Result>("GetReportList", isOrderByDateParameter, orderByNameParameter, doctorNameParameter, clinicNameParameter, limitParameter, offSetParameter);
        }
    
        public virtual ObjectResult<GetReportListByUserId_Result> GetReportListByUserId(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetReportListByUserId_Result>("GetReportListByUserId", userIdParameter);
        }
    
        public virtual ObjectResult<GetTabletList_Result> GetTabletList(Nullable<long> prescriptionId)
        {
            var prescriptionIdParameter = prescriptionId.HasValue ?
                new ObjectParameter("PrescriptionId", prescriptionId) :
                new ObjectParameter("PrescriptionId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetTabletList_Result>("GetTabletList", prescriptionIdParameter);
        }
    
        public virtual ObjectResult<GetTabletNameByUserId_Result> GetTabletNameByUserId(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetTabletNameByUserId_Result>("GetTabletNameByUserId", userIdParameter);
        }
    
        public virtual ObjectResult<GetUpcommingActivitiesListByUserId_Result> GetUpcommingActivitiesListByUserId(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetUpcommingActivitiesListByUserId_Result>("GetUpcommingActivitiesListByUserId", userIdParameter);
        }
    
        public virtual ObjectResult<GetUserProfileDetailById_Result> GetUserProfileDetailById(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<GetUserProfileDetailById_Result>("GetUserProfileDetailById", userIdParameter);
        }
    
        public virtual ObjectResult<ListOfReferPatient_Result> ListOfReferPatient()
        {
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<ListOfReferPatient_Result>("ListOfReferPatient");
        }
    
        public virtual ObjectResult<Login_Result> Login(string phoneNo, string deviceId, string deviceType)
        {
            var phoneNoParameter = phoneNo != null ?
                new ObjectParameter("PhoneNo", phoneNo) :
                new ObjectParameter("PhoneNo", typeof(string));
    
            var deviceIdParameter = deviceId != null ?
                new ObjectParameter("DeviceId", deviceId) :
                new ObjectParameter("DeviceId", typeof(string));
    
            var deviceTypeParameter = deviceType != null ?
                new ObjectParameter("DeviceType", deviceType) :
                new ObjectParameter("DeviceType", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<Login_Result>("Login", phoneNoParameter, deviceIdParameter, deviceTypeParameter);
        }
    
        public virtual ObjectResult<LoginDoc_Result> LoginDoc(string email, string phoneNo, string password)
        {
            var emailParameter = email != null ?
                new ObjectParameter("Email", email) :
                new ObjectParameter("Email", typeof(string));
    
            var phoneNoParameter = phoneNo != null ?
                new ObjectParameter("PhoneNo", phoneNo) :
                new ObjectParameter("PhoneNo", typeof(string));
    
            var passwordParameter = password != null ?
                new ObjectParameter("Password", password) :
                new ObjectParameter("Password", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<LoginDoc_Result>("LoginDoc", emailParameter, phoneNoParameter, passwordParameter);
        }
    
        public virtual int Logout(Nullable<long> userId)
        {
            var userIdParameter = userId.HasValue ?
                new ObjectParameter("UserId", userId) :
                new ObjectParameter("UserId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("Logout", userIdParameter);
        }
    
        public virtual ObjectResult<PatientList_Result> PatientList(Nullable<long> doctorId, string name)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var nameParameter = name != null ?
                new ObjectParameter("Name", name) :
                new ObjectParameter("Name", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<PatientList_Result>("PatientList", doctorIdParameter, nameParameter);
        }
    
        public virtual ObjectResult<ReferPatient_Result> ReferPatient()
        {
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<ReferPatient_Result>("ReferPatient");
        }
    
        public virtual int SaveBookAppoinment(string reasonForVisit, Nullable<System.DateTime> appointmentDate, Nullable<System.DateTime> appointmentTime, Nullable<long> doctorId, Nullable<long> patientId)
        {
            var reasonForVisitParameter = reasonForVisit != null ?
                new ObjectParameter("ReasonForVisit", reasonForVisit) :
                new ObjectParameter("ReasonForVisit", typeof(string));
    
            var appointmentDateParameter = appointmentDate.HasValue ?
                new ObjectParameter("AppointmentDate", appointmentDate) :
                new ObjectParameter("AppointmentDate", typeof(System.DateTime));
    
            var appointmentTimeParameter = appointmentTime.HasValue ?
                new ObjectParameter("AppointmentTime", appointmentTime) :
                new ObjectParameter("AppointmentTime", typeof(System.DateTime));
    
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var patientIdParameter = patientId.HasValue ?
                new ObjectParameter("PatientId", patientId) :
                new ObjectParameter("PatientId", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("SaveBookAppoinment", reasonForVisitParameter, appointmentDateParameter, appointmentTimeParameter, doctorIdParameter, patientIdParameter);
        }
    
        public virtual ObjectResult<TodaysAppoinmentList_Result> TodaysAppoinmentList(Nullable<long> doctorId, Nullable<System.DateTime> appointmentDate)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var appointmentDateParameter = appointmentDate.HasValue ?
                new ObjectParameter("AppointmentDate", appointmentDate) :
                new ObjectParameter("AppointmentDate", typeof(System.DateTime));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<TodaysAppoinmentList_Result>("TodaysAppoinmentList", doctorIdParameter, appointmentDateParameter);
        }
    
        public virtual int UpdateDoctorProfile(Nullable<long> doctorId, string firstName, string middelName, string lastName, string address, Nullable<int> postalCode, string phoneNo, string email)
        {
            var doctorIdParameter = doctorId.HasValue ?
                new ObjectParameter("DoctorId", doctorId) :
                new ObjectParameter("DoctorId", typeof(long));
    
            var firstNameParameter = firstName != null ?
                new ObjectParameter("FirstName", firstName) :
                new ObjectParameter("FirstName", typeof(string));
    
            var middelNameParameter = middelName != null ?
                new ObjectParameter("MiddelName", middelName) :
                new ObjectParameter("MiddelName", typeof(string));
    
            var lastNameParameter = lastName != null ?
                new ObjectParameter("LastName", lastName) :
                new ObjectParameter("LastName", typeof(string));
    
            var addressParameter = address != null ?
                new ObjectParameter("Address", address) :
                new ObjectParameter("Address", typeof(string));
    
            var postalCodeParameter = postalCode.HasValue ?
                new ObjectParameter("PostalCode", postalCode) :
                new ObjectParameter("PostalCode", typeof(int));
    
            var phoneNoParameter = phoneNo != null ?
                new ObjectParameter("PhoneNo", phoneNo) :
                new ObjectParameter("PhoneNo", typeof(string));
    
            var emailParameter = email != null ?
                new ObjectParameter("Email", email) :
                new ObjectParameter("Email", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("UpdateDoctorProfile", doctorIdParameter, firstNameParameter, middelNameParameter, lastNameParameter, addressParameter, postalCodeParameter, phoneNoParameter, emailParameter);
        }
    
        public virtual int UpdateOtp(Nullable<long> otp, string phoneNo)
        {
            var otpParameter = otp.HasValue ?
                new ObjectParameter("Otp", otp) :
                new ObjectParameter("Otp", typeof(long));
    
            var phoneNoParameter = phoneNo != null ?
                new ObjectParameter("PhoneNo", phoneNo) :
                new ObjectParameter("PhoneNo", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction("UpdateOtp", otpParameter, phoneNoParameter);
        }
    
        public virtual ObjectResult<Nullable<int>> UserCount(Nullable<long> roleType)
        {
            var roleTypeParameter = roleType.HasValue ?
                new ObjectParameter("RoleType", roleType) :
                new ObjectParameter("RoleType", typeof(long));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<Nullable<int>>("UserCount", roleTypeParameter);
        }
    }
}
